Index: gcc/doc/invoke.texi
===================================================================
--- gcc/doc/invoke.texi	(revision 121569)
+++ gcc/doc/invoke.texi	(working copy)
@@ -891,6 +891,12 @@
 
 @item @var{file}.hh
 @itemx @var{file}.H
+@itemx @var{file}.hp
+@itemx @var{file}.hxx
+@itemx @var{file}.hpp
+@itemx @var{file}.HPP
+@itemx @var{file}.h++
+@itemx @var{file}.tcc
 C++ header file to be turned into a precompiled header.
 
 @item @var{file}.f
@@ -1101,7 +1107,8 @@
 @cindex C++ source file suffixes
 C++ source files conventionally use one of the suffixes @samp{.C},
 @samp{.cc}, @samp{.cpp}, @samp{.CPP}, @samp{.c++}, @samp{.cp}, or
-@samp{.cxx}; C++ header files often use @samp{.hh} or @samp{.H}; and
+@samp{.cxx}; C++ header files often use @samp{.hh}, @samp{.hpp},
+@samp{.H}, or (for shared template code) @samp{.tcc}; and
 preprocessed C++ files use the suffix @samp{.ii}.  GCC recognizes
 files with these names and compiles them as C++ programs even if you
 call the compiler the same way as for compiling C programs (usually
Index: gcc/cp/lang-specs.h
===================================================================
--- gcc/cp/lang-specs.h	(revision 121569)
+++ gcc/cp/lang-specs.h	(working copy)
@@ -34,6 +34,12 @@
   {".C",   "@c++", 0, 0, 0},
   {".CPP", "@c++", 0, 0, 0},
   {".H",   "@c++-header", 0, 0, 0},
+  {".hpp", "@c++-header", 0, 0, 0},
+  {".hp",  "@c++-header", 0, 0, 0},
+  {".hxx", "@c++-header", 0, 0, 0},
+  {".h++", "@c++-header", 0, 0, 0},
+  {".HPP", "@c++-header", 0, 0, 0},
+  {".tcc", "@c++-header", 0, 0, 0},
   {".hh",  "@c++-header", 0, 0, 0},
   {"@c++-header",
     "%{E|M|MM:cc1plus -E %(cpp_options) %2 %(cpp_debug_options)}\
Index: gcc/cp/g++spec.c
===================================================================
--- gcc/cp/g++spec.c	(revision 121569)
+++ gcc/cp/g++spec.c	(working copy)
@@ -228,6 +228,12 @@
 	    {
 	      if ((len <= 2 || strcmp (argv[i] + (len - 2), ".H") != 0)
 		  && (len <= 2 || strcmp (argv[i] + (len - 2), ".h") != 0)
+		  && (len <= 4 || strcmp (argv[i] + (len - 4), ".hpp") != 0)
+		  && (len <= 3 || strcmp (argv[i] + (len - 3), ".hp") != 0)
+		  && (len <= 4 || strcmp (argv[i] + (len - 4), ".hxx") != 0)
+		  && (len <= 4 || strcmp (argv[i] + (len - 4), ".h++") != 0)
+		  && (len <= 4 || strcmp (argv[i] + (len - 4), ".HPP") != 0)
+		  && (len <= 4 || strcmp (argv[i] + (len - 4), ".tcc") != 0)
 		  && (len <= 3 || strcmp (argv[i] + (len - 3), ".hh") != 0))
 		library = 1;
 	    }
